Index: GTP/trunk/App/Demos/Vis/CHC_revisited/src/RenderTraverser.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/src/RenderTraverser.cpp	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/src/RenderTraverser.cpp	(revision 2784)
@@ -1,5 +1,4 @@
 #include "RenderTraverser.h"
 #include "glInterface.h"
-#include "Timers.h"
 #include "Camera.h"
 #include "SceneEntity.h"
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/src/common.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/src/common.cpp	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/src/common.cpp	(revision 2784)
@@ -139,5 +139,5 @@
 		_ftime(&mtime);
 
-		return 1000*(1000*mtime.time + mtime.millitm);
+		return 1000*(1000*(long)mtime.time + (long)mtime.millitm);
 	}
 #endif
@@ -162,5 +162,5 @@
 		static struct _timeb mtime;
 		_ftime(&mtime);
-		return 1000*(1000*mtime.time + mtime.millitm);
+		return 1000*(1000*(long)mtime.time + (long)mtime.millitm);
 	}
 #endif
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/src/chcdemo.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/src/chcdemo.cpp	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/src/chcdemo.cpp	(revision 2784)
@@ -157,25 +157,28 @@
 	BinaryLoader loader;
 
-	//const string filename("house_test.dem");
-	//const string filename("city_demo.dem");
-	const string filename("city.dem");
-	//const string filename("roofs.dem");
+	//const string filename("data/city/model/city.dem");
+	const string filename = string(model_path + "city.dem");
 
 	if (loader.Load(filename, sceneEntities))
 		cout << "scene " << filename << " loaded" << endl;
 	else
+	{
 		cerr << "loading scene " << filename << " failed" << endl;
-
+		exit(0);
+	}
+
+	const string bvh_filename = string(model_path + "city.bvh");
 	BvhLoader bvhLoader;
-	//bvh = bvhLoader.Load("roofs.bvh", sceneEntities);
-	bvh = bvhLoader.Load("city.bvh", sceneEntities);
-	//bvh = bvhLoader.Load("city_demo.bvh", sceneEntities);
-	//bvh = bvhLoader.Load("house_test.bvh", sceneEntities);
+	bvh = bvhLoader.Load(bvh_filename, sceneEntities);
+	//bvh = bvhLoader.Load("data/city/model/city.bvh", sceneEntities);
+
+	if (!bvh)
+	{
+		cerr << "loading bvh " << bvh_filename << " failed" << endl;
+		exit(0);
+	}
 
 	bvh->SetCamera(camera);
 	ResetTraverser();
-
-	//camera->LookAtBox(sceneBox);
-	//camera->LookInBox(bvh->GetBox());
 
 	camera->SetDirection(Vector3(0.961829f, 0.273652f, 0.0f));
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/src/BinaryLoader.cpp
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/src/BinaryLoader.cpp	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/src/BinaryLoader.cpp	(revision 2784)
@@ -97,5 +97,5 @@
 
 		//cout << "loading texture " << texname << " with len " << texnameSize << " id: " << id << endl;
-		Texture *tex = new Texture(texname);
+		Texture *tex = new Texture(model_path + texname);
 
 		mTextureTable[i] = tex;
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/src/common.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/src/common.h	(revision 2782)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/src/common.h	(revision 2784)
@@ -462,4 +462,9 @@
 
 
+//////
+//-- model directory
+
+static std::string model_path("data/city/model/");
+
 ///////////
 //-- typedefs
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/src/Timers.h
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/src/Timers.h	(revision 2782)
+++ 	(revision )
@@ -1,47 +1,0 @@
-/** Various time measuring routines
-    @author Jiri Bittner
-*/
-
-#ifndef __TIMERS_H
-#define __TIMERS_H
-
-void initTiming();
-
-void finishTiming();
-
-long getTime();
-
-double timeDiff(long t1,long t2);
-
-char * timeString();
-
-
-/** Example of usage:
-see timers.h for diffirent possibilities of what is really measured.
-
-
-InitTiming();
-
-long t1, t2, t3;
-
-t1 = GetTime();
-
-Algortihm1();
-
-t2 = GetTime();
-
-Algorithm2();
-
-t3 = GetTime();
-
-
-cout<<"Algorithm 1"<<TimeDiff(t1, t2)<<"[ms]"<<endl;
-cout<<"Algorithm 2"<<TimeDiff(t2, t3)<<"[ms]"<<endl;
-
-
-FinishTiming();
-
-*/
-
-
-#endif
Index: GTP/trunk/App/Demos/Vis/CHC_revisited/chc_revisited.vcproj
===================================================================
--- GTP/trunk/App/Demos/Vis/CHC_revisited/chc_revisited.vcproj	(revision 2783)
+++ GTP/trunk/App/Demos/Vis/CHC_revisited/chc_revisited.vcproj	(revision 2784)
@@ -18,6 +18,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
+			OutputDirectory="$(SolutionDir)/bin/$(ConfigurationName)"
+			IntermediateDirectory="obj/$(ConfigurationName)"
 			ConfigurationType="1"
 			CharacterSet="1"
@@ -41,6 +41,6 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="Devil/include;GL"
-				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE"
+				AdditionalIncludeDirectories="libs;libs/GL;libs/Devil/include;src"
+				PreprocessorDefinitions="WIN32;_DEBUG;_CONSOLE;_CRT_SECURE_NO_WARNINGS"
 				MinimalRebuild="true"
 				BasicRuntimeChecks="3"
@@ -65,5 +65,5 @@
 				AdditionalDependencies="glut32.lib glew32s.lib glew32.lib DevIL.lib ILUT.lib"
 				LinkIncremental="2"
-				AdditionalLibraryDirectories="GL;Devil/lib"
+				AdditionalLibraryDirectories="libs/GL;libs/Devil/lib"
 				GenerateDebugInformation="true"
 				SubSystem="1"
@@ -97,6 +97,6 @@
 		<Configuration
 			Name="Release|Win32"
-			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
-			IntermediateDirectory="$(ConfigurationName)"
+			OutputDirectory="$(SolutionDir)/bin/$(ConfigurationName)"
+			IntermediateDirectory="obj/$(ConfigurationName)"
 			ConfigurationType="1"
 			CharacterSet="1"
@@ -127,5 +127,5 @@
 				EnableFiberSafeOptimizations="true"
 				AdditionalIncludeDirectories="libs;libs/GL;libs/Devil/include;src"
-				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE"
+				PreprocessorDefinitions="WIN32;NDEBUG;_CONSOLE; _CRT_SECURE_NO_WARNINGS"
 				StringPooling="true"
 				RuntimeLibrary="2"