Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneEntity.h
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneEntity.h	(revision 2792)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/SceneEntity.h	(revision 2793)
@@ -16,5 +16,5 @@
 
 /** Class representing a scene entity.
-    A scene entity basicly consists of geometry, transformation, and a material
+    A scene entity basically consists of geometry, transformation, and a material
 */
 class SceneEntity
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Geometry.h
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Geometry.h	(revision 2782)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/Geometry.h	(revision 2793)
@@ -20,4 +20,5 @@
 	*/
 	Geometry(Vector3 *vertices, Vector3 *normals, float *texcoords, int numVertices, bool delData);
+
 	~Geometry();
 	/** Render the geometry
@@ -40,6 +41,4 @@
 	//////////
 
-	unsigned int mVboId;
-
 	Vector3 *mVertices;
 
@@ -47,4 +46,6 @@
 
 	float *mTexCoords;
+
+	unsigned int mVboId;
 
 	int mNumVertices;
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderQueue.h
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderQueue.h	(revision 2782)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/RenderQueue.h	(revision 2793)
@@ -35,5 +35,6 @@
 	*/
 	void Clear();
-
+	/** Returns the number entities currently in the queue.
+	*/
 	int GetSize() const { return (int)mEntities.size(); }
 
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 2792)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/chcdemo.cpp	(revision 2793)
@@ -34,4 +34,6 @@
 /// the hierarchy
 Bvh *bvh = NULL;
+/// handles scene loading
+BinaryLoader *loader = NULL;
 /// the scene camera
 Camera *camera = NULL;
@@ -50,5 +52,5 @@
 int maxBatchSize = 50;
 
-const float keyForwardMotion = 1.0f;
+const float keyForwardMotion = 0.5f;
 const float keyRotation = 0.05f;
 
@@ -131,5 +133,5 @@
 	int returnCode = 0;
 
-//#ifdef _CRT_SET
+#ifdef _CRT_SET
 
 	//Now just call this function at the start of your program and if you're
@@ -142,5 +144,5 @@
 	_CrtSetReportMode(_CRT_ASSERT,_CRTDBG_MODE_FILE);
 	_CrtSetReportFile(_CRT_ASSERT,_CRTDBG_FILE_STDERR); 
-//#endif
+#endif
 
 
@@ -170,10 +172,11 @@
 	MiddleMotion(0, 0);
 
-	BinaryLoader loader;
+
+	loader = new BinaryLoader();
 
 	//const string filename("data/city/model/city.dem");
 	const string filename = string(model_path + "city.dem");
 
-	if (loader.Load(filename, sceneEntities))
+	if (loader->Load(filename, sceneEntities))
 		cout << "scene " << filename << " loaded" << endl;
 	else
@@ -183,6 +186,4 @@
 		exit(0);
 	}
-	CleanUp();
-		exit(0);
 
 	const string bvh_filename = string(model_path + "city.bvh");
@@ -974,4 +975,6 @@
 	DEL_PTR(visualization);
 	DEL_PTR(camera);
+
+	DEL_PTR(loader);
 }
 
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BinaryLoader.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BinaryLoader.cpp	(revision 2792)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/BinaryLoader.cpp	(revision 2793)
@@ -68,8 +68,5 @@
 	{
 		trafo = new Matrix4x4();
-		//*trafo = IdentityMatrix();
 		str.read(reinterpret_cast<char *>(trafo->x), sizeof(Matrix4x4));
-		//str.read(reinterpret_cast<char *>(trafo), sizeof(Matrix4x4));
-		//cout << "m:\n" << *trafo<<endl;
 	}
 
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/AxisAlignedBox3.cpp
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/AxisAlignedBox3.cpp	(revision 2782)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/src/AxisAlignedBox3.cpp	(revision 2793)
@@ -243,5 +243,4 @@
 		{
 			cerr << "ERROR in AxisAlignedBox3::GetVertex N=" << N <<  "\n";
-			exit(0);
 		}
 	}
Index: /GTP/trunk/App/Demos/Vis/FriendlyCulling/chc_revisited.vcproj
===================================================================
--- /GTP/trunk/App/Demos/Vis/FriendlyCulling/chc_revisited.vcproj	(revision 2792)
+++ /GTP/trunk/App/Demos/Vis/FriendlyCulling/chc_revisited.vcproj	(revision 2793)
@@ -464,5 +464,5 @@
 				</File>
 				<File
-					RelativePath=".\Geometry.h"
+					RelativePath=".\src\Geometry.h"
 					>
 				</File>